Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| JavaTM 2 Platform Std. Ed. v1.4.0
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## javax.swing
Class LayoutFocusTraversalPolicy

    java.lang.Object
      |
      +--java.awt.FocusTraversalPolicy
            |
            +--javax.swing.InternalFrameFocusTraversalPolicy
                  |
                  +--javax.swing.SortingFocusTraversalPolicy
                        |
                        +--javax.swing.LayoutFocusTraversalPolicy

All Implemented Interfaces:
  Serializable

public class LayoutFocusTraversalPolicy
extends SortingFocusTraversalPolicy
implements Serializable

A SortingFocusTraversalPolicy which sorts Components based on their size, position, and orientation. Based on their size and position, Components are roughly categorized into rows and columns. For a Container with horizontal orientation, columns run left-to-right or right-to-left, and rows run top- to-bottom. For a Container with vertical orientation, columns run top-to- bottom and rows run left-to-right or right-to-left. See `ComponentOrientation` for more information. All columns in a row are fully traversed before proceeding to the next row.

Since:
  1.4
See Also:
  `ComponentOrientation`

Constructor Summary
`LayoutFocusTraversalPolicy()` Constructs a LayoutFocusTraversalPolicy.

Method Summary
`protected boolean` | `accept(Component aComponent)` Determines whether the specified `Component` is an acceptable choice as the new focus owner.
`Component` | `getComponentAfter(Container focusCycleRoot, Component aComponent)` Returns the Component that should receive the focus after aComponent.
`Component` | `getComponentBefore(Container focusCycleRoot, Component aComponent)` Returns the Component that should receive the focus before aComponent.
`Component` | `getFirstComponent(Container focusCycleRoot)` Returns the first Component in the traversal cycle.
`Component` | `getLastComponent(Container focusCycleRoot)` Returns the last Component in the traversal cycle.

Methods inherited from class javax.swing.SortingFocusTraversalPolicy
`getComparator, getDefaultComponent, getImplicitDownCycleTraversal, setComparator, setImplicitDownCycleTraversal`

Methods inherited from class javax.swing.InternalFrameFocusTraversalPolicy
`getInitialComponent`

Methods inherited from class java.awt.FocusTraversalPolicy
`getInitialComponent`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Constructor Detail

### LayoutFocusTraversalPolicy

    public LayoutFocusTraversalPolicy()

  Constructs a LayoutFocusTraversalPolicy.

Method Detail

### getComponentAfter

    public Component getComponentAfter(Container focusCycleRoot,
                                       Component aComponent)

  Returns the Component that should receive the focus after aComponent. focusCycleRoot must be a focus cycle root of aComponent.

  By default, LayoutFocusTraversalPolicy implicitly transfers focus down- cycle. That is, during normal focus traversal, the Component traversed after a focus cycle root will be the focus-cycle-root's default Component to focus. This behavior can be disabled using the `setImplicitDownCycleTraversal` method.

  Overrides:
    `getComponentAfter` in class `SortingFocusTraversalPolicy`
  Parameters:
    `focusCycleRoot` - a focus cycle root of aComponent
    `aComponent` - a (possibly indirect) child of focusCycleRoot, or focusCycleRoot itself
  Returns:
    the Component that should receive the focus after aComponent, or null if no suitable Component can be found
  Throws:
    `IllegalArgumentException` - if focusCycleRoot is not a focus cycle root of aComponent, or if either focusCycleRoot or aComponent is null

### getComponentBefore

    public Component getComponentBefore(Container focusCycleRoot,
                                        Component aComponent)

  Returns the Component that should receive the focus before aComponent. focusCycleRoot must be a focus cycle root of aComponent.

  By default, LayoutFocusTraversalPolicy implicitly transfers focus down- cycle. That is, during normal focus traversal, the Component traversed after a focus cycle root will be the focus-cycle-root's default Component to focus. This behavior can be disabled using the `setImplicitDownCycleTraversal` method.

  Overrides:
    `getComponentBefore` in class `SortingFocusTraversalPolicy`
  Parameters:
    `focusCycleRoot` - a focus cycle root of aComponent
    `aComponent` - a (possibly indirect) child of focusCycleRoot, or focusCycleRoot itself
  Returns:
    the Component that should receive the focus before aComponent, or null if no suitable Component can be found
  Throws:
    `IllegalArgumentException` - if focusCycleRoot is not a focus cycle root of aComponent, or if either focusCycleRoot or aComponent is null

### getFirstComponent

    public Component getFirstComponent(Container focusCycleRoot)

  Returns the first Component in the traversal cycle. This method is used to determine the next Component to focus when traversal wraps in the forward direction.

  Overrides:
    `getFirstComponent` in class `SortingFocusTraversalPolicy`
  Parameters:
    `focusCycleRoot` - the focus cycle root whose first Component is to be returned
  Returns:
    the first Component in the traversal cycle when focusCycleRoot is the focus cycle root, or null if no suitable Component can be found
  Throws:
    `IllegalArgumentException` - if focusCycleRoot is null

### getLastComponent

    public Component getLastComponent(Container focusCycleRoot)

  Returns the last Component in the traversal cycle. This method is used to determine the next Component to focus when traversal wraps in the reverse direction.

  Overrides:
    `getLastComponent` in class `SortingFocusTraversalPolicy`
  Parameters:
    `focusCycleRoot` - the focus cycle root whose last Component is to be returned
  Returns:
    the last Component in the traversal cycle when focusCycleRoot is the focus cycle root, or null if no suitable Component can be found
  Throws:
    `IllegalArgumentException` - if focusCycleRoot is null

### accept

    protected boolean accept(Component aComponent)

  Determines whether the specified `Component` is an acceptable choice as the new focus owner. This method performs the following sequence of operations:
  1. Checks whether `aComponent` is visible, displayable, enabled, and focusable. If any of these properties is `false`, this method returns `false`.
  2. If `aComponent` is an instance of `JTable`, returns `true`.
  3. If `aComponent` is an instance of `JComboBox`, then returns the value of `aComponent.getUI().isFocusTraversable(aComponent)`.
  4. If `aComponent` is a `JComponent` with a `JComponent.WHEN_FOCUSED` `InputMap` that is neither `null` nor empty, returns `true`.
  5. Returns the value of `DefaultFocusTraversalPolicy.accept(aComponent)`.

  Overrides:
    `accept` in class `SortingFocusTraversalPolicy`
  Parameters:
    `aComponent` - the `Component` whose fitness as a focus owner is to be tested
  Returns:
    `true` if `aComponent` is a valid choice for a focus owner; otherwise `false`
  See Also:
    `Component.isVisible()`, `Component.isDisplayable()`, `Component.isEnabled()`, `Component.isFocusable()`, `ComboBoxUI.isFocusTraversable(javax.swing.JComboBox)`, `JComponent.getInputMap(int)`, `DefaultFocusTraversalPolicy.accept(java.awt.Component)`

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| JavaTM 2 Platform Std. Ed. v1.4.0
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Submit a bug or feature
For further API reference and developer documentation, see Java 2 SDK SE Developer Documentation. That documentation contains more detailed, developer-targeted descriptions, with conceptual overviews, definitions of terms, workarounds, and working code examples.

Java, Java 2D, and JDBC are trademarks or registered trademarks of Sun Microsystems, Inc. in the US and other countries.
Copyright 1993-2002 Sun Microsystems, Inc. 901 San Antonio Road
Palo Alto, California, 94303, U.S.A. All Rights Reserved.